> For the complete documentation index, see [llms.txt](https://docs.hello-robot.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hello-robot.com/stretch4-ros2-repo/stretch_description.md).

# stretch\_description

### Overview

The purpose of *stretch\_description* is simply to provide a launch file to visualize the URDF in Rviz. None of the files (`.xacro`, `.urdf`, `.stl`, etc.) live in this repo anymore; they have been moved to [stretch4\_urdf](https://github.com/hello-robot/stretch4_urdf).

You can launch the visualization using:

```bash
ros2 launch stretch_description display.launch.py
```

By default, the visualization uses your robot's URDF. To visualize another end-effector, batch, or variant of robot, you can run:

```bash
ros2 launch stretch_description display.launch.py urdf_file:=<path_to_urdf>
```

### Details

`display.launch.py` loads the URDF from [*stretch4\_urdf*](https://github.com/hello-robot/stretch4_urdf) using:

```python
from stretch4_urdf import get_robot_params, get_urdf

model_name, batch_name, tool_name = get_robot_params()
robot_description_content = get_urdf(model_name=model_name, batch_name=batch_name, tool_name=tool_name)
robot_state_publisher = Node(package='robot_state_publisher',
                             executable='robot_state_publisher',
                             parameters=[{'robot_description': robot_description_content}])
```

`model` and `tool` is defined for your robot in Stretch's parameters:

```
import stretch4_body.robot
r = stretch4_body.robot.Robot()
model = r.params['model_name']
tool = r.params['tool']
```

To access other URDFs, XACROs, or individual meshes from *stretch4\_urdf*, look through [Coming Soon](#TODO) for details on these assets are organized.

### License and Patents

Patents are pending that cover aspects of the Stretch mobile manipulator.

For license information, please see the LICENSE files.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hello-robot.com/stretch4-ros2-repo/stretch_description.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
